
Index: test/org/mifos/application/collectionsheet/business/CollectionSheetBOTest.java
===================================================================
--- test/org/mifos/application/collectionsheet/business/CollectionSheetBOTest.java	(revision 0)
+++ test/org/mifos/application/collectionsheet/business/CollectionSheetBOTest.java	(revision 0)
@@ -0,0 +1,36 @@
+package org.mifos.application.collectionsheet.business;
+
+import java.sql.Date;
+import java.util.Calendar;
+import java.util.HashMap;
+import java.util.List;
+
+import org.hibernate.Session;
+import org.hibernate.Transaction;
+import org.mifos.application.NamedQueryConstants;
+import org.mifos.application.collectionsheet.persistence.CollectionSheetPersistence;
+import org.mifos.framework.MifosTestCase;
+import org.mifos.framework.hibernate.helper.HibernateUtil;
+import org.mifos.framework.util.helpers.DateUtils;
+
+public class CollectionSheetBOTest extends MifosTestCase {
+	public void testRetrieveCollectionSheetMeetingDateReturnsAllCollectionSheetsForSpecifiedMeeting()
+			throws Exception {
+		Session session = HibernateUtil.getSessionTL();
+		Transaction transaction = session.beginTransaction();
+		Date year2010 = DateUtils.getSqlDate(2010, Calendar.JANUARY, 1);
+		CollectionSheetBO collectionSheet = new CollectionSheetBO();
+		collectionSheet.setCollSheetDate(year2010);
+		collectionSheet.setRunDate(new Date(System.currentTimeMillis()));
+		collectionSheet.create();
+		HashMap queryParameters = new HashMap();
+		queryParameters.put("MEETING_DATE", year2010);
+		List matchingCollectionSheets = new CollectionSheetPersistence()
+				.executeNamedQuery(
+						NamedQueryConstants.COLLECTION_SHEETS_FOR_MEETING_DATE,
+						queryParameters);
+		assertEquals(1, matchingCollectionSheets.size());
+		assertEquals(collectionSheet, matchingCollectionSheets.get(0));
+		transaction.rollback();
+	}
+}
Index: test/org/mifos/application/collectionsheet/business/CollectionSheetSavingDetailsEntityFixture.java
===================================================================
--- test/org/mifos/application/collectionsheet/business/CollectionSheetSavingDetailsEntityFixture.java	(revision 0)
+++ test/org/mifos/application/collectionsheet/business/CollectionSheetSavingDetailsEntityFixture.java	(revision 0)
@@ -0,0 +1,11 @@
+package org.mifos.application.collectionsheet.business;
+
+public class CollectionSheetSavingDetailsEntityFixture {
+
+	public static CollSheetSavingsDetailsEntity createSavingsDetails(Integer accountId) {
+		CollSheetSavingsDetailsEntity savingDetails = new CollSheetSavingsDetailsEntity();
+		savingDetails.setAccountId(accountId);
+		return savingDetails;
+	}
+
+}
Index: test/org/mifos/application/collectionsheet/business/CollectionSheetLoanDetailsEntityFixture.java
===================================================================
--- test/org/mifos/application/collectionsheet/business/CollectionSheetLoanDetailsEntityFixture.java	(revision 0)
+++ test/org/mifos/application/collectionsheet/business/CollectionSheetLoanDetailsEntityFixture.java	(revision 0)
@@ -0,0 +1,16 @@
+package org.mifos.application.collectionsheet.business;
+
+
+public class CollectionSheetLoanDetailsEntityFixture {
+
+	public static CollSheetLnDetailsEntity createLoanDetails() {
+		return new CollSheetLnDetailsEntity();
+	}
+
+	public static CollSheetLnDetailsEntity createLoanDetails(Integer accountId) {
+		CollSheetLnDetailsEntity collectionSheet = new CollSheetLnDetailsEntity();
+		collectionSheet.setAccountId(accountId);
+		return collectionSheet;
+	}
+
+}
Index: test/org/mifos/application/collectionsheet/business/CollectionSheetReportTestSuite.java
===================================================================
--- test/org/mifos/application/collectionsheet/business/CollectionSheetReportTestSuite.java	(revision 0)
+++ test/org/mifos/application/collectionsheet/business/CollectionSheetReportTestSuite.java	(revision 0)
@@ -0,0 +1,19 @@
+package org.mifos.application.collectionsheet.business;
+
+import junit.framework.Test;
+import junit.framework.TestCase;
+import junit.framework.TestSuite;
+
+import org.mifos.application.reports.business.service.CollectionSheetReportServiceTest;
+import org.mifos.application.reports.business.service.CollectionSheetServiceTest;
+
+
+public class CollectionSheetReportTestSuite extends TestSuite {
+	public static Test suite() throws Exception {
+		TestSuite suite = new TestSuite();
+		suite.addTestSuite(CollectionSheetBOTest.class);
+		suite.addTestSuite(CollectionSheetReportServiceTest.class);
+		suite.addTestSuite(CollectionSheetServiceTest.class);
+		return suite;
+	}
+}
Index: test/org/mifos/application/collectionsheet/business/CollectionSheetBOFixture.java
===================================================================
--- test/org/mifos/application/collectionsheet/business/CollectionSheetBOFixture.java	(revision 0)
+++ test/org/mifos/application/collectionsheet/business/CollectionSheetBOFixture.java	(revision 0)
@@ -0,0 +1,13 @@
+package org.mifos.application.collectionsheet.business;
+
+import java.util.HashSet;
+
+import org.mifos.framework.util.helpers.DateUtils;
+
+public class CollectionSheetBOFixture {
+
+	public static CollectionSheetBO createCollectionSheet() {
+		return new CollectionSheetBO(DateUtils.sqlToday(), DateUtils.sqlToday(), new HashSet<CollSheetCustBO>(), null);
+	}
+
+}
Index: test/org/mifos/application/collectionsheet/business/CollectionSheetCustomerBOFixture.java
===================================================================
--- test/org/mifos/application/collectionsheet/business/CollectionSheetCustomerBOFixture.java	(revision 0)
+++ test/org/mifos/application/collectionsheet/business/CollectionSheetCustomerBOFixture.java	(revision 0)
@@ -0,0 +1,10 @@
+package org.mifos.application.collectionsheet.business;
+
+public class CollectionSheetCustomerBOFixture {
+
+	public static CollSheetCustBO createCollectionSheet() {
+		CollSheetCustBO collectionSheet = new CollSheetCustBO();
+		collectionSheet.setCollectionSheet(CollectionSheetBOFixture.createCollectionSheet());
+		return collectionSheet;
+	}
+}
Index: test/org/mifos/application/reports/persistence/DateSelectionItemPersistenceTest.java
===================================================================
--- test/org/mifos/application/reports/persistence/DateSelectionItemPersistenceTest.java	(revision 0)
+++ test/org/mifos/application/reports/persistence/DateSelectionItemPersistenceTest.java	(revision 0)
@@ -0,0 +1,44 @@
+package org.mifos.application.reports.persistence;
+
+import java.util.Calendar;
+import java.util.Date;
+import java.util.List;
+
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+import org.mifos.application.reports.ui.DateSelectionItem;
+import org.mifos.framework.MifosTestCase;
+import org.mifos.framework.util.helpers.DateUtils;
+
+public class DateSelectionItemPersistenceTest extends MifosTestCase {
+
+	private static final Date FROM_DATE = DateUtils.getDate(2007,
+								Calendar.JUNE, 1);
+	private static final Short LOAN_OFFICER_ID = Short.valueOf("19");
+	private static final Short BRANCH_ID = Short.valueOf("2");
+
+	public void testRetrievesMeetingDatesFromNamedQueryParamForCenter() throws Exception {
+		List<DateSelectionItem> meetingDates = null;
+		try {
+			meetingDates = new DateSelectionItemPersistence().getMeetingDates(
+					BRANCH_ID, LOAN_OFFICER_ID, 5609,
+					CustomerLevel.CENTER.getValue(), FROM_DATE);
+		}
+		catch (Exception e) {
+			fail("Should not throw any exceptions");
+		}
+		assertFalse(meetingDates.isEmpty());
+	}
+
+	public void testRetrievesMeetingDatesFromNamedQueryParamForGroupLevel() throws Exception {
+		List<DateSelectionItem> meetingDates = null;
+		try {
+			meetingDates = new DateSelectionItemPersistence().getMeetingDates(
+					BRANCH_ID, LOAN_OFFICER_ID, 5612,
+					CustomerLevel.GROUP.getValue(), FROM_DATE);
+		}
+		catch (Exception e) {
+			fail("Should not throw any exceptions");
+		}
+		assertFalse(meetingDates.isEmpty());
+	}
+}
Index: test/org/mifos/application/reports/struts/action/BirtReportValidationFilterTest.java
===================================================================
--- test/org/mifos/application/reports/struts/action/BirtReportValidationFilterTest.java	(revision 0)
+++ test/org/mifos/application/reports/struts/action/BirtReportValidationFilterTest.java	(revision 0)
@@ -0,0 +1,24 @@
+package org.mifos.application.reports.struts.action;
+
+import junit.framework.TestCase;
+import servletunit.FilterChainSimulator;
+import servletunit.HttpServletRequestSimulator;
+import servletunit.HttpServletResponseSimulator;
+import servletunit.ServletContextSimulator;
+
+public class BirtReportValidationFilterTest extends TestCase {
+	public void testValidationForCollectionSheetReportWhenBranchIdIsSelect()
+			throws Exception {
+		BirtReportValidationFilter validationFilter = new BirtReportValidationFilter();
+		HttpServletRequestSimulator request = new HttpServletRequestSimulator(
+						new ServletContextSimulator());
+		HttpServletResponseSimulator response = new HttpServletResponseSimulator();
+		FilterChainSimulator filterChain = new FilterChainSimulator();
+		request.setParameterValue("branchId", new String[]{"-2"});
+		validationFilter.doFilter(request,
+				response, filterChain);
+		assertEquals(HttpServletResponseSimulator.SC_MOVED_TEMPORARILY,response.getStatusCode());
+		assertEquals("/mifos", response.getHeader("Location"));
+		
+	}
+}
Index: test/org/mifos/application/reports/business/DetailedAgingPortfolioReportParametersTest.java
===================================================================
--- test/org/mifos/application/reports/business/DetailedAgingPortfolioReportParametersTest.java	(revision 0)
+++ test/org/mifos/application/reports/business/DetailedAgingPortfolioReportParametersTest.java	(revision 0)
@@ -0,0 +1,65 @@
+package org.mifos.application.reports.business;
+
+import org.mifos.application.reports.business.validator.Errors;
+import static org.easymock.classextension.EasyMock.createMock;
+import static org.easymock.classextension.EasyMock.replay;
+import static org.easymock.classextension.EasyMock.verify;
+
+import junit.framework.TestCase;
+
+public class DetailedAgingPortfolioReportParametersTest extends TestCase {
+
+	private Errors errorsMock;
+
+	public void testValidatorNoErrorIfAllParamsValid() throws Exception {
+		DetailedAgingPortfolioReportParameters reportParameters = new DetailedAgingPortfolioReportParameters(
+				DetailedAgingPortfolioReportParameters.VALID_ID,
+				DetailedAgingPortfolioReportParameters.VALID_ID,
+				DetailedAgingPortfolioReportParameters.VALID_ID);
+		replay(errorsMock);
+		reportParameters.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	public void testValidatorReturnsErrorIfBranchIdIsSelect() throws Exception {
+		DetailedAgingPortfolioReportParameters reportParameters = new DetailedAgingPortfolioReportParameters(
+				DetailedAgingPortfolioReportParameters.INVALID_ID,
+				DetailedAgingPortfolioReportParameters.VALID_ID,
+				DetailedAgingPortfolioReportParameters.VALID_ID);
+		errorsMock.rejectValue(DetailedAgingPortfolioReportParameters.BRANCH_ID_PARAM, 
+				DetailedAgingPortfolioReportParameters.BRANCH_ID_INVALID_MSG);
+		replay(errorsMock);
+		reportParameters.validate(errorsMock);
+		verify(errorsMock);
+	}
+	
+	public void testValidatorReturnsErrorIfLoanOfficerIsSelect() throws Exception {
+		DetailedAgingPortfolioReportParameters reportParameters = new DetailedAgingPortfolioReportParameters(
+				DetailedAgingPortfolioReportParameters.VALID_ID,
+				DetailedAgingPortfolioReportParameters.INVALID_ID,
+				DetailedAgingPortfolioReportParameters.VALID_ID);
+		errorsMock.rejectValue(DetailedAgingPortfolioReportParameters.LOAN_OFFICER_ID_PARAM, 
+				DetailedAgingPortfolioReportParameters.LOAN_OFFICER_ID_INVALID_MSG);
+		replay(errorsMock);
+		reportParameters.validate(errorsMock);
+		verify(errorsMock);
+	}
+	
+	public void testValidatorReturnsErrorIfLoanProductIsSelect() throws Exception {
+		DetailedAgingPortfolioReportParameters reportParameters = new DetailedAgingPortfolioReportParameters(
+				DetailedAgingPortfolioReportParameters.VALID_ID,
+				DetailedAgingPortfolioReportParameters.VALID_ID,
+				DetailedAgingPortfolioReportParameters.INVALID_ID);
+		errorsMock.rejectValue(DetailedAgingPortfolioReportParameters.LOAN_PRODUCT_ID,
+				DetailedAgingPortfolioReportParameters.LOAN_PRODUCT_ID_INVALID_MSG);
+		replay(errorsMock);
+		reportParameters.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	@Override
+	protected void setUp() throws Exception {
+		super.setUp();
+		errorsMock = createMock(Errors.class);
+	}
+}
